/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.model.impl.ReferenceableByXmadslVariableImpl;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.ComposedElement;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.GuiElement;
import org.openxma.dsl.pom.model.IDummy;
import org.openxma.dsl.pom.model.IElementOnWhichCanBeAttached;
import org.openxma.dsl.pom.model.IElementWithLayoutData;
import org.openxma.dsl.pom.model.IGuiElementWithEvent;
import org.openxma.dsl.pom.model.IReferenceableByStatementVariable;
import org.openxma.dsl.pom.model.LayoutDataProperty;
import org.openxma.dsl.pom.model.ListBox;
import org.openxma.dsl.pom.model.MultiselectionFlag;
import org.openxma.dsl.pom.model.SimpleElement;
import org.openxma.dsl.pom.model.TabableFlag;
import org.openxma.dsl.pom.model.TextProperty;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>List Box</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ListBoxImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ListBoxImpl#getLayoutProperties <em>Layout Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ListBoxImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ListBoxImpl#getTabableFlag <em>Tabable Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ListBoxImpl#getMultiselectionFlag <em>Multiselection Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.ListBoxImpl#getTextProperties <em>Text Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ListBoxImpl extends ReferenceableByXmadslVariableImpl implements ListBox {
	/**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getName()
     * @generated
     * @ordered
     */
	protected static final String NAME_EDEFAULT = null;

	/**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getName()
     * @generated
     * @ordered
     */
	protected String name = NAME_EDEFAULT;

	/**
     * The cached value of the '{@link #getLayoutProperties() <em>Layout Properties</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getLayoutProperties()
     * @generated
     * @ordered
     */
	protected EList<LayoutDataProperty> layoutProperties;

	/**
     * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getFieldFlags()
     * @generated
     * @ordered
     */
	protected EList<FieldFlag> fieldFlags;

	/**
     * The cached value of the '{@link #getTabableFlag() <em>Tabable Flag</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getTabableFlag()
     * @generated
     * @ordered
     */
    protected TabableFlag tabableFlag;

    /**
     * The cached value of the '{@link #getMultiselectionFlag() <em>Multiselection Flag</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getMultiselectionFlag()
     * @generated
     * @ordered
     */
    protected MultiselectionFlag multiselectionFlag;

    /**
     * The cached value of the '{@link #getTextProperties() <em>Text Properties</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getTextProperties()
     * @generated
     * @ordered
     */
	protected EList<TextProperty> textProperties;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected ListBoxImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return PomPackage.Literals.LIST_BOX;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<LayoutDataProperty> getLayoutProperties() {
        if (layoutProperties == null) {
            layoutProperties = new EObjectContainmentEList<LayoutDataProperty>(LayoutDataProperty.class, this, PomPackage.LIST_BOX__LAYOUT_PROPERTIES);
        }
        return layoutProperties;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<FieldFlag> getFieldFlags() {
        if (fieldFlags == null) {
            fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.LIST_BOX__FIELD_FLAGS);
        }
        return fieldFlags;
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public TabableFlag getTabableFlag() {
        return tabableFlag;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetTabableFlag(TabableFlag newTabableFlag, NotificationChain msgs) {
        TabableFlag oldTabableFlag = tabableFlag;
        tabableFlag = newTabableFlag;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.LIST_BOX__TABABLE_FLAG, oldTabableFlag, newTabableFlag);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setTabableFlag(TabableFlag newTabableFlag) {
        if (newTabableFlag != tabableFlag) {
            NotificationChain msgs = null;
            if (tabableFlag != null)
                msgs = ((InternalEObject)tabableFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.LIST_BOX__TABABLE_FLAG, null, msgs);
            if (newTabableFlag != null)
                msgs = ((InternalEObject)newTabableFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.LIST_BOX__TABABLE_FLAG, null, msgs);
            msgs = basicSetTabableFlag(newTabableFlag, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.LIST_BOX__TABABLE_FLAG, newTabableFlag, newTabableFlag));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public MultiselectionFlag getMultiselectionFlag() {
        return multiselectionFlag;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetMultiselectionFlag(MultiselectionFlag newMultiselectionFlag, NotificationChain msgs) {
        MultiselectionFlag oldMultiselectionFlag = multiselectionFlag;
        multiselectionFlag = newMultiselectionFlag;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.LIST_BOX__MULTISELECTION_FLAG, oldMultiselectionFlag, newMultiselectionFlag);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setMultiselectionFlag(MultiselectionFlag newMultiselectionFlag) {
        if (newMultiselectionFlag != multiselectionFlag) {
            NotificationChain msgs = null;
            if (multiselectionFlag != null)
                msgs = ((InternalEObject)multiselectionFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.LIST_BOX__MULTISELECTION_FLAG, null, msgs);
            if (newMultiselectionFlag != null)
                msgs = ((InternalEObject)newMultiselectionFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.LIST_BOX__MULTISELECTION_FLAG, null, msgs);
            msgs = basicSetMultiselectionFlag(newMultiselectionFlag, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.LIST_BOX__MULTISELECTION_FLAG, newMultiselectionFlag, newMultiselectionFlag));
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
        return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.LIST_BOX__NAME, oldName, name));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<TextProperty> getTextProperties() {
        if (textProperties == null) {
            textProperties = new EObjectContainmentEList<TextProperty>(TextProperty.class, this, PomPackage.LIST_BOX__TEXT_PROPERTIES);
        }
        return textProperties;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case PomPackage.LIST_BOX__LAYOUT_PROPERTIES:
                return ((InternalEList<?>)getLayoutProperties()).basicRemove(otherEnd, msgs);
            case PomPackage.LIST_BOX__FIELD_FLAGS:
                return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
            case PomPackage.LIST_BOX__TABABLE_FLAG:
                return basicSetTabableFlag(null, msgs);
            case PomPackage.LIST_BOX__MULTISELECTION_FLAG:
                return basicSetMultiselectionFlag(null, msgs);
            case PomPackage.LIST_BOX__TEXT_PROPERTIES:
                return ((InternalEList<?>)getTextProperties()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case PomPackage.LIST_BOX__NAME:
                return getName();
            case PomPackage.LIST_BOX__LAYOUT_PROPERTIES:
                return getLayoutProperties();
            case PomPackage.LIST_BOX__FIELD_FLAGS:
                return getFieldFlags();
            case PomPackage.LIST_BOX__TABABLE_FLAG:
                return getTabableFlag();
            case PomPackage.LIST_BOX__MULTISELECTION_FLAG:
                return getMultiselectionFlag();
            case PomPackage.LIST_BOX__TEXT_PROPERTIES:
                return getTextProperties();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case PomPackage.LIST_BOX__NAME:
                setName((String)newValue);
                return;
            case PomPackage.LIST_BOX__LAYOUT_PROPERTIES:
                getLayoutProperties().clear();
                getLayoutProperties().addAll((Collection<? extends LayoutDataProperty>)newValue);
                return;
            case PomPackage.LIST_BOX__FIELD_FLAGS:
                getFieldFlags().clear();
                getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
                return;
            case PomPackage.LIST_BOX__TABABLE_FLAG:
                setTabableFlag((TabableFlag)newValue);
                return;
            case PomPackage.LIST_BOX__MULTISELECTION_FLAG:
                setMultiselectionFlag((MultiselectionFlag)newValue);
                return;
            case PomPackage.LIST_BOX__TEXT_PROPERTIES:
                getTextProperties().clear();
                getTextProperties().addAll((Collection<? extends TextProperty>)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case PomPackage.LIST_BOX__NAME:
                setName(NAME_EDEFAULT);
                return;
            case PomPackage.LIST_BOX__LAYOUT_PROPERTIES:
                getLayoutProperties().clear();
                return;
            case PomPackage.LIST_BOX__FIELD_FLAGS:
                getFieldFlags().clear();
                return;
            case PomPackage.LIST_BOX__TABABLE_FLAG:
                setTabableFlag((TabableFlag)null);
                return;
            case PomPackage.LIST_BOX__MULTISELECTION_FLAG:
                setMultiselectionFlag((MultiselectionFlag)null);
                return;
            case PomPackage.LIST_BOX__TEXT_PROPERTIES:
                getTextProperties().clear();
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case PomPackage.LIST_BOX__NAME:
                return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
            case PomPackage.LIST_BOX__LAYOUT_PROPERTIES:
                return layoutProperties != null && !layoutProperties.isEmpty();
            case PomPackage.LIST_BOX__FIELD_FLAGS:
                return fieldFlags != null && !fieldFlags.isEmpty();
            case PomPackage.LIST_BOX__TABABLE_FLAG:
                return tabableFlag != null;
            case PomPackage.LIST_BOX__MULTISELECTION_FLAG:
                return multiselectionFlag != null;
            case PomPackage.LIST_BOX__TEXT_PROPERTIES:
                return textProperties != null && !textProperties.isEmpty();
        }
        return super.eIsSet(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
        if (baseClass == GuiElement.class) {
            switch (derivedFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IElementOnWhichCanBeAttached.class) {
            switch (derivedFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == ComposedElement.class) {
            switch (derivedFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IDummy.class) {
            switch (derivedFeatureID) {
                case PomPackage.LIST_BOX__NAME: return PomPackage.IDUMMY__NAME;
                default: return -1;
            }
        }
        if (baseClass == IElementWithLayoutData.class) {
            switch (derivedFeatureID) {
                case PomPackage.LIST_BOX__LAYOUT_PROPERTIES: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES;
                case PomPackage.LIST_BOX__FIELD_FLAGS: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS;
                case PomPackage.LIST_BOX__TABABLE_FLAG: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG;
                default: return -1;
            }
        }
        if (baseClass == SimpleElement.class) {
            switch (derivedFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IGuiElementWithEvent.class) {
            switch (derivedFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IReferenceableByStatementVariable.class) {
            switch (derivedFeatureID) {
                default: return -1;
            }
        }
        return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
        if (baseClass == GuiElement.class) {
            switch (baseFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IElementOnWhichCanBeAttached.class) {
            switch (baseFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == ComposedElement.class) {
            switch (baseFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IDummy.class) {
            switch (baseFeatureID) {
                case PomPackage.IDUMMY__NAME: return PomPackage.LIST_BOX__NAME;
                default: return -1;
            }
        }
        if (baseClass == IElementWithLayoutData.class) {
            switch (baseFeatureID) {
                case PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES: return PomPackage.LIST_BOX__LAYOUT_PROPERTIES;
                case PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS: return PomPackage.LIST_BOX__FIELD_FLAGS;
                case PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG: return PomPackage.LIST_BOX__TABABLE_FLAG;
                default: return -1;
            }
        }
        if (baseClass == SimpleElement.class) {
            switch (baseFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IGuiElementWithEvent.class) {
            switch (baseFeatureID) {
                default: return -1;
            }
        }
        if (baseClass == IReferenceableByStatementVariable.class) {
            switch (baseFeatureID) {
                default: return -1;
            }
        }
        return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (name: ");
        result.append(name);
        result.append(')');
        return result.toString();
    }

} //ListBoxImpl
